myGame.OutfitSelect.prototype = {
  preload: function() {
    // Preload images for this state
  },

  create: function() {
    //Audio
    if (!myGame.music.homeMorning.isPlaying) {
      myGame.music.homeMorning.play('',0,1,true);
    }

    this.physics.startSystem(Phaser.Physics.ARCADE);

    game.add.sprite( 0, 0, 'outfit-background');

    if (myGame.day == 1) {
      var dayLocationText = "to school";
    } else if (myGame.day == 2) {
      var dayLocationText = "to work";
    } else if (myGame.day == 3) {
      var dayLocationText = "to work";
    } else if (myGame.day == 4) {
      var dayLocationText = "to school";
    } else {
      var dayLocationText = "on your day off";
    }

    //Outfit
    myGame.outfit = {};

    //Prompt text
    myGame.drawPromptText("What should you wear " + dayLocationText + "?");

    // Timer
    myGame.resetTimer();
    myGame.setupTimer(this);

    //Base character
    this.baseCharacter = this.add.sprite( 100, 300, 'baseCharacter_content');
    this.baseCharacter.scale.x = 0.5;
    this.baseCharacter.scale.y = 0.5;
    this.physics.enable(this.baseCharacter, Phaser.Physics.ARCADE);

    myGame.player.cuteness = 0;
    myGame.player.sexiness = 0;
    myGame.player.outlandishness = 0;
    myGame.player.style = "";


    // Hairstyles group
    this.hairstyles = this.add.group();

    //Hair
    this.hair1 = this.hairstyles.create(this.baseCharacter.x + this.baseCharacter.width/2, this.baseCharacter.y, "hair1");
    this.hair1.name = "hair1";
    this.hair1.location = 0;
    this.hair1.stats = {
      cuteness: 0,
      sexiness: 0,
      outlandishness: 0
    }

    myGame.outfit.hair = this.hair1;

    this.hair2 = this.hairstyles.create(this.baseCharacter.x + this.baseCharacter.width/2, this.baseCharacter.y-21, "hair2");
    this.hair2.name = "hair2";
    this.hair2.location = 21;
    this.hair2.stats = {
      cuteness: 5,
      sexiness: 2,
      outlandishness: 0
    }

    this.hair3 = this.hairstyles.create(this.baseCharacter.x + this.baseCharacter.width/2-1, this.baseCharacter.y-21, "hair3");
    this.hair3.name = "hair3";
    this.hair3.location = 21;
    this.hair3.stats = {
      cuteness: 5,
      sexiness: 0,
      outlandishness: 6
    }

    this.hair4 = this.hairstyles.create(this.baseCharacter.x + this.baseCharacter.width/2, this.baseCharacter.y-30, "hair4");
    this.hair4.name = "hair4";
    this.hair4.location = 30;
    this.hair4.stats = {
      cuteness: 5,
      sexiness: 2,
      outlandishness: 3
    }

    this.hair5 = this.hairstyles.create(this.baseCharacter.x + this.baseCharacter.width/2, this.baseCharacter.y-18, "hair5");
    this.hair5.name = "hair5";
    this.hair5.location = 18;
    this.hair5.stats = {
      cuteness: 4,
      sexiness: 4,
      outlandishness: 1
    }

    this.hairstyles.forEach(function(hair){
      hair.inputEnabled = true;
      hair.events.onInputDown.add(this.changeHair, this);
      hair.events.onInputOver.add(this.hairHighlight, this);
      hair.events.onInputOut.add(this.hairHighlightFade, this);
      hair.scale = {x:0.5, y:0.5};
      hair.anchor.setTo(0.5,0);
      hair.tint = 0x999999;

      if (hair != this.hair1) {
        hair.visible = false;
      }
    }, this);

    // clothes
    this.clothes = game.add.group();
    var topLocation = 213;
    var bottomLocation = 395;
    var shoeLocation = this.baseCharacter.height;

    //Shoes 1 - red flats
    this.shoes1 = this.clothes.create( 1450, 1100, 'shoes1');
    this.shoes1.name = "shoes1";
    this.shoes1.desc = "Cute red flats. You love this color.";
    this.shoes1.originalPosition = [this.shoes1.x, this.shoes1.y];
    this.shoes1.location = shoeLocation + 2;
    this.shoes1.stats = {
      cuteness: 5,
      sexiness: 0,
      outlandishness: 0
    }

    //Shoes 2 - yellow heels
    this.shoes2 = this.clothes.create( 1250, 1100, 'shoes2');
    this.shoes2.name = "shoes2";
    this.shoes2.desc = "Mustard-colored, ladylike heels.";
    this.shoes2.originalPosition = [this.shoes2.x, this.shoes2.y];
    this.shoes2.location = shoeLocation + 8;
    this.shoes2.stats = {
      cuteness: 3,
      sexiness: 3,
      outlandishness: 3
    }

    //Shoes 3 - pink flats
    this.shoes3 = this.clothes.create( 1050, 1100, 'shoes3');
    this.shoes3.name = "shoes3";
    this.shoes3.desc = "Frilly ballet flats in a cute color.";
    this.shoes3.originalPosition = [this.shoes3.x, this.shoes3.y];
    this.shoes3.location = shoeLocation + 5;
    this.shoes3.stats = {
      cuteness: 3,
      sexiness: 0,
      outlandishness: 3
    }

    //Shoes 4 - black vans
    this.shoes4 = this.clothes.create( 850, 1100, 'shoes4');
    this.shoes4.name = "shoes4";
    this.shoes4.desc = "Plain, chill skater sneakers.";
    this.shoes4.originalPosition = [this.shoes4.x, this.shoes4.y];
    this.shoes4.location = shoeLocation + 10;
    this.shoes4.stats = {
      cuteness: 0,
      sexiness: 0,
      outlandishness: 0
    }

    //Shoes 5 - black boots
    this.shoes5 = this.clothes.create( 650, 1100, 'shoes5');
    this.shoes5.name = "shoes5";
    this.shoes5.desc = "Motorcycle-chic ankle boots.";
    this.shoes5.originalPosition = [this.shoes5.x, this.shoes5.y];
    this.shoes5.location = shoeLocation + 10;
    this.shoes5.stats = {
      cuteness: -2,
      sexiness: 2,
      outlandishness: 5
    }

    //Bottom 1 - shorts
    this.bottom1 = this.clothes.create( 1475, 650, 'bottom1');
    this.bottom1.name = "bottom1";
    this.bottom1.desc = "Super-short shorts. Very sexy. Too sexy?";
    this.bottom1.originalPosition = [this.bottom1.x, this.bottom1.y];
    this.bottom1.location = bottomLocation;
    this.bottom1.stats = {
      cuteness: 0,
      sexiness: 5,
      outlandishness: 0
    }

    //Bottom 2 - gray skinny jeans
    this.bottom2 = this.clothes.create( 1340, 650, 'bottom2');
    this.bottom2.name = "bottom2";
    this.bottom2.desc = "Gray jeggings go with almost anything.";
    this.bottom2.originalPosition = [this.bottom2.x, this.bottom2.y];
    this.bottom2.location = bottomLocation;
    this.bottom2.stats = {
      cuteness: 3,
      sexiness: 2,
      outlandishness: 0
    }

    //Bottom 3 - large blue jeans
    this.bottom3 = this.clothes.create( 1200, 650, 'bottom3');
    this.bottom3.name = "bottom3";
    this.bottom3.desc = "Loose blue jeans for when you're feeling lazy.";
    this.bottom3.originalPosition = [this.bottom3.x, this.bottom3.y];
    this.bottom3.location = bottomLocation;
    this.bottom3.stats = {
      cuteness: 0,
      sexiness: 0,
      outlandishness: 0
    }

    //Bottom 4 - white skirt
    this.bottom4 = this.clothes.create( 1050, 650, 'bottom4');
    this.bottom4.name = "bottom4";
    this.bottom4.desc = "A basic cute skirt matches with anything.";
    this.bottom4.originalPosition = [this.bottom4.x, this.bottom4.y];
    this.bottom4.location = bottomLocation-15;
    this.bottom4.stats = {
      cuteness: 5,
      sexiness: 3,
      outlandishness: 0
    }

    //Bottom 5 - tutu
    this.bottom5 = this.clothes.create( 920, 650, 'bottom5');
    this.bottom5.name = "bottom5";
    this.bottom5.desc = "A statement piece you bought after reading Teen Vogue.";
    this.bottom5.originalPosition = [this.bottom5.x, this.bottom5.y];
    this.bottom5.location = bottomLocation-30;
    this.bottom5.stats = {
      cuteness: 5,
      sexiness: 0,
      outlandishness: 8
    }

    //Bottom 6 - culottes
    this.bottom6 = this.clothes.create( 790, 650, 'bottom6');
    this.bottom6.name = "bottom6";
    this.bottom6.desc = "Professional-looking, shapeless pants.";
    this.bottom6.originalPosition = [this.bottom6.x, this.bottom6.y];
    this.bottom6.location = bottomLocation-15;
    this.bottom6.stats = {
      cuteness: 3,
      sexiness: 0,
      outlandishness: 2
    }

    //Bottom 7 - frilly skirt
    this.bottom7 = this.clothes.create( 660, 650, 'bottom7');
    this.bottom7.name = "bottom7";
    this.bottom7.desc = "A sweet frilly skirt inspired by Japanese fashion.";
    this.bottom7.originalPosition = [this.bottom7.x, this.bottom7.y];
    this.bottom7.location = bottomLocation;
    this.bottom7.stats = {
      cuteness: 5,
      sexiness: 0,
      outlandishness: 5
    }

    // Top 1 - short red shirt
    this.top1 = this.clothes.create( 1475, 300, 'top1');
    this.top1.name = "top1";
    this.top1.desc = "A sexy crop top in your favorite color.";
    this.top1.originalPosition = [this.top1.x, this.top1.y];
    this.top1.location = topLocation;
    this.top1.stats = {
      cuteness: 0,
      sexiness: 5,
      outlandishness: 0
    }

    // Top 2 - blue denim shirt
    this.top2 = this.clothes.create( 1340, 300, 'top2');
    this.top2.name = "top2";
    this.top2.desc = "Loose shirts are so cute. Denim is even cuter!";
    this.top2.originalPosition = [this.top2.x, this.top2.y];
    this.top2.location = topLocation-13;
    this.top2.stats = {
      cuteness: 5,
      sexiness: -2,
      outlandishness: 1
    }

    // Top 3 - Gray Sweater
    this.top3 = this.clothes.create( 1200, 300, 'top3');
    this.top3.name = "top3";
    this.top3.desc = "This sweater is pretty boring but it has cute slits!";
    this.top3.originalPosition = [this.top3.x, this.top3.y];
    this.top3.location = topLocation;
    this.top3.stats = {
      cuteness: 2,
      sexiness: 0,
      outlandishness: 0
    }

    // Top 4 - Pink voting shirt
    this.top4 = this.clothes.create( 1050, 300, 'top4');
    this.top4.name = "top4";
    this.top4.desc = "One of your favorite T-shirts! You've been getting into pink.";
    this.top4.originalPosition = [this.top4.x, this.top4.y];
    this.top4.location = topLocation;
    this.top4.stats = {
      cuteness: 5,
      sexiness: 0,
      outlandishness: 2
    }

    // Top 5 - Striped shirt
    this.top5 = this.clothes.create( 920, 300, 'top5');
    this.top5.name = "top5";
    this.top5.desc = "This striped shirt is very cute. It even has beads on the collar.";
    this.top5.originalPosition = [this.top5.x, this.top5.y];
    this.top5.location = topLocation;
    this.top5.stats = {
      cuteness: 5,
      sexiness: 0,
      outlandishness: 0
    }

    // Top 6 - White T-shirt
    this.top6 = this.clothes.create( 800, 300, 'top6');
    this.top6.name = "top6";
    this.top6.desc = "A plain white tee. Boring. Goes with everything.";
    this.top6.originalPosition = [this.top6.x, this.top6.y];
    this.top6.location = topLocation;
    this.top6.stats = {
      cuteness: 0,
      sexiness: -2,
      outlandishness: -5
    }

    // Top 7 - Pink shirt
    this.top7 = this.clothes.create( 680, 300, 'top7');
    this.top7.name = "top7";
    this.top7.desc = "A tight pink shirt. Cute and sexy!";
    this.top7.originalPosition = [this.top7.x, this.top7.y];
    this.top7.location = topLocation;
    this.top7.stats = {
      cuteness: 4,
      sexiness: 5,
      outlandishness: 0
    }

    //Clothing input
    this.clothes.forEach(function(item){
      if (item.name.indexOf("shoes") > -1) {
        item.anchor.setTo(0.5, 1);
      } else {
        item.anchor.setTo(0.5, 0);
      }
      item.scale.x = 0.5;
      item.scale.y = 0.5;
      game.physics.enable(item, Phaser.Physics.ARCADE);
      item.inputEnabled = true;
      item.input.enableDrag();
      item.events.onInputOver.add(this.showHoverInfo, this);
      item.events.onInputOut.add(this.hideHoverInfo, this);
      item.events.onInputDown.add(this.selectClothing, this);
      item.events.onDragStart.add(this.moveClothing, this);
      item.events.onDragStop.add(this.dropClothing, this);

      if ((myGame.player.usedClothing.tops.indexOf(item.name) > -1) || myGame.player.usedClothing.bottoms.indexOf(item.name) > -1) {
        item.kill();
      }
    }, this);

    // Comb
    this.comb = game.add.sprite( 450, 300, 'comb');
    this.comb.scale.x = 0.75;
    this.comb.scale.y = 0.75;
    this.comb.desc = 'A comb to change hairstyles.';
    this.comb.inputEnabled = true;
    this.comb.events.onInputDown.add(this.changeHair, this);
    this.comb.events.onInputOver.add(this.hairHighlight, this);
    this.comb.events.onInputOut.add(this.hairHighlightFade, this);
    this.comb.events.onInputOver.add(this.showHoverInfo, this);
    this.comb.events.onInputOut.add(this.hideHoverInfo, this);

    // continue button
    myGame.setupContinueButton(this);

    // Hover text
    myGame.setupHoverText(this);

    // Setup quit button
    myGame.setupQuitButton(this);
  },

  update: function() {
    myGame.updateTimer();

    if (myGame.outfit.top && myGame.outfit.bottom && myGame.outfit.shoes) {
      this.continueButton.visible = true;
    } else {
      this.continueButton.visible = false;
    }
  },

  showHoverInfo: function(sprite, pointer){
    if (!sprite.wearing) {
      this.hoverText.setText(sprite.desc);
      this.hoverText.visible = true;
      this.hoverText.x = sprite.x;
      this.hoverText.y = sprite.y + sprite.height + 20;

      if (this.hoverText.x + this.hoverText.width/2 > game.width) {
        this.hoverText.x = game.width - this.hoverText.width/2 - 20;
      }

      if (sprite.name.indexOf("shoes") > -1) {
        this.hoverText.y -= sprite.height;
      }

      if (this.hoverText.y + this.hoverText.height > game.height) {
        this.hoverText.y = game.height - this.hoverText.height - 20;
      }
      myGame.displayHoverTextBox(this);
    }
  },

  hideHoverInfo: function(){
    this.hoverText.visible = false;
    this.hoverTextBox.visible = false;
  },

  moveClothing: function(sprite, pointer) {
    sprite.x = pointer.x;
    if (sprite.name.indexOf("shoes") > -1) {
      sprite.y = pointer.y + sprite.height/2;
    } else {
      sprite.y = pointer.y - sprite.height/2;
    }
    this.hideHoverInfo();
  },

  selectClothing: function(sprite, pointer) {
    myGame.sounds.outfit.pickup.play();
    this.moveClothing(sprite, pointer);
    this.hideHoverInfo();
  },

  dropClothing: function(sprite) {
    myGame.sounds.outfit.drop.play();
    this.physics.arcade.overlap(sprite, this.baseCharacter, this.wearClothing, null, this);

    if (!this.physics.arcade.overlap(sprite, this.baseCharacter)){
      this.checkOutfitProgress(sprite)
      sprite.wearing = false;
    }
    this.hideHoverInfo();
  },

  checkOutfitProgress: function(sprite) {
    //tops
    if (myGame.outfit.top) {
      if (myGame.outfit.top.name.indexOf(sprite.name) > -1) {
        myGame.outfit.top = null;
      }
    }

    // bottoms
    if (myGame.outfit.bottom) {
      if (myGame.outfit.bottom.name.indexOf(sprite.name) > -1) {
        myGame.outfit.bottom = null;
      }
    }

    // bottoms
    if (myGame.outfit.shoes) {
      if (myGame.outfit.shoes.name.indexOf(sprite.name) > -1) {
        myGame.outfit.shoes = null;
      }
    }

    //shoes
  },
  wearClothing: function(clothing, character) {
    clothing.x = character.x + (character.width/2);
    clothing.y = character.y + clothing.location;
    clothing.wearing = true;

    if (clothing.name.indexOf("top") > -1) {
      //Move previously selected item back
      if (myGame.outfit.top != null && myGame.outfit.top.name != clothing.name) {
        var itemToMove = this.clothes.children[this.clothes.getChildIndex(myGame.outfit.top)];
        this.moveItemBack(itemToMove);
      }

      //Set new item
      myGame.outfit.top = clothing;
    } else if (clothing.name.indexOf("bottom") > -1) {
      //Move previously selected item back
      if (myGame.outfit.bottom != null && myGame.outfit.bottom.name != clothing.name) {
        var itemToMove = this.clothes.children[this.clothes.getChildIndex(myGame.outfit.bottom)];
        this.moveItemBack(itemToMove);
      }

      //Set new item
      myGame.outfit.bottom = clothing;

      // Move it over by 1
      clothing.x-=1;
    } else if (clothing.name.indexOf("shoes") > -1) {
      //Move previously selected item back
      if (myGame.outfit.shoes != null && myGame.outfit.shoes.name != clothing.name) {
        var itemToMove = this.clothes.children[this.clothes.getChildIndex(myGame.outfit.shoes)];
        this.moveItemBack(itemToMove);
      }

      //Set new item
      myGame.outfit.shoes = clothing;
    }
  },

  moveItemBack: function(item) {
    item.x = item.originalPosition[0];
    item.y = item.originalPosition[1];
    item.wearing = false;
  },

  changeHair: function(){
    myGame.sounds.outfit.hair.play();
    switch (myGame.outfit.hair.name) {
      case "hair1":
        this.hair1.visible = false;
        this.hair2.visible = true;
        myGame.outfit.hair = this.hair2;
        break;
      case "hair2":
        this.hair2.visible = false;
        this.hair3.visible = true;
        myGame.outfit.hair = this.hair3;
        break;
      case "hair3":
        this.hair3.visible = false;
        this.hair4.visible = true;
        myGame.outfit.hair = this.hair4;
        break;
      case "hair4":
        this.hair4.visible = false;
        this.hair5.visible = true;
        myGame.outfit.hair = this.hair5;
        break;
      case "hair5":
        this.hair5.visible = false;
        this.hair1.visible = true;
        myGame.outfit.hair = this.hair1;
        break;
    }
  },

  hairHighlight: function(hair) {
    hair.tint = 0xFFFFFF;
  },

  hairHighlightFade: function(hair) {
    hair.tint = 0x999999;
  },

  continue: function(){
    //Add used clothing to list
    var usedTopCount = myGame.player.usedClothing.tops.length;
    var usedBottomCount = myGame.player.usedClothing.bottoms.length;
    myGame.player.usedClothing.tops[usedTopCount] = myGame.outfit.top.name;
    myGame.player.usedClothing.bottoms[usedBottomCount] = myGame.outfit.bottom.name;

    //Sounds
    myGame.sounds.dialog.buttonClick1.play();

    //Stats
    myGame.player.cuteness += myGame.outfit.top.stats.cuteness + myGame.outfit.bottom.stats.cuteness + myGame.outfit.hair.stats.cuteness;
    myGame.player.sexiness += myGame.outfit.top.stats.sexiness + myGame.outfit.bottom.stats.sexiness + myGame.outfit.hair.stats.sexiness;
    myGame.player.outlandishness += myGame.outfit.top.stats.outlandishness + myGame.outfit.bottom.stats.outlandishness + myGame.outfit.hair.stats.outlandishness;

    this.state.start('OutfitEvaluation');
  }
}
